tree grammar CmisEcmQueryWalker;

options {
    tokenVocab = CmisEcmLexer;
    ASTLabelType = CommonTree;
    output = AST;
}

import CmisBaseQueryWalker;

@header {
/*
 * THIS FILE IS AUTO-GENERATED, DO NOT EDIT.
 */
package com.sap.ecm.gateway.cmis.queries.parser;

import java.math.BigDecimal;

import org.apache.chemistry.opencmis.server.support.query.*;
}

@members {
    public Tree getWherePredicateTree() {
      return gCmisBaseQueryWalker.getWherePredicateTree();
    }

    protected void mismatch(IntStream input, int ttype, BitSet follow) throws RecognitionException
    {
      gCmisBaseQueryWalker.mismatch(input, ttype, follow);
    }

    public void recoverFromMismatchedSet(IntStream input, RecognitionException e, antlr.collections.impl.BitSet follow) throws RecognitionException
    {
      gCmisBaseQueryWalker.recoverFromMismatchedSet(input, e, follow);
    }

}


// For CMIS SQL it will be sufficient to stop on first error:
@rulecatch {
    catch (RecognitionException e) {
        throw e;
    }
}

root [QueryObject go, PredicateWalkerBase pw] throws CmisQueryException:
      query [go, pw];
		

value_expression returns [CmisSelector result]:
      column_reference
      {
          $result = $column_reference.result;
      }
    | SCORE^
        {
            $result = new FunctionReference(FunctionReference.CmisQlFunction.SCORE);
        }
    | COUNT^
        {
            $result = new FunctionReference(FunctionReference.EcmQlFunction.COUNT);
        }
    | ^(SUM column_reference)
        {
            $result = new FunctionReference(FunctionReference.EcmQlFunction.SUM, $column_reference.result);
        }
    ;

